//---------------------------------------------------------------------------------
//     GT-511Cx.     
//---------------------------------------------------------------------------------
#include "hardware.h" //     
#include "uart.h" //     
#include "lcd.h" //     
#include "knop.h" //     
#include "GT511.h" //       GT-511Cx
#include "i2c.h" //     
#include "wdt.h" //     

//     
volatile extern unsigned int rejim_ustr;  //    
volatile extern unsigned int podrejim_mast;  //   -

//      UART
volatile extern unsigned char rx0_byte; //   UART0
volatile extern unsigned char rx1_byte; //   UART1

volatile extern unsigned int rx0_byte_f; //    UART0
volatile extern unsigned int rx1_byte_f; //    UART1
 
//        GT-511Cx 
extern unsigned char Command_Packet[];   // ,  ,     
extern unsigned char ACK_Packet[SB_OEM_PKT_SIZE] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}; 
                           // ,    ,      

volatile extern unsigned int tx_Command;       //       
volatile extern unsigned int rx_ACK_Command;   //         
volatile extern unsigned int rx_ACK_Command_ERR;  //          

//      
static unsigned int knoptick = 0;  //       

//       
static unsigned int zwuk_H_tick = 0;  //      
static unsigned int zwuk_L_tick = 0;  //      
//static unsigned int test_s = 0;   //           

static unsigned int zwuk_H_s = 0;   //            
static unsigned int zwuk_L_s = 0;   //            

static unsigned int dlit_zwuk_H = 0;   //       
static unsigned int dlit_zwuk_L = 0;   //       

volatile extern unsigned int pred_dlit_H;  //      
volatile extern unsigned int pred_dlit_L;  //      

volatile extern unsigned int zwuk_H_ON;  //     
volatile extern unsigned int zwuk_L_ON;  //     

//      I2C
volatile unsigned int I2C_addres = 0;  //  24LC64
volatile unsigned int I2Cwr_byte = 0; //     24LC64
volatile unsigned int wr_rd = 0;  // / 24LC64
volatile unsigned int end_rd = 0;  //   24LC64
volatile unsigned int end_wr = 0;  //   24LC64
static unsigned int NUM_byte = 0; //      24LC64

//    
static unsigned char k = 0;      //  

//   ----------------------------------------------------
void CPUinit(void)
{
// PLL ()
  PLLCFG_bit.MSEL=3;    //.   PLL   #define  
  PLLCFG_bit.PSEL=1;    //.   PLL   #define  
  PLLFEED=0xAA;
  PLLFEED=0x55;
  PLLCON_bit.PLLE=1;                 //  PLL    
  PLLFEED=0xAA;
  PLLFEED=0x55;
  while(!(PLLSTAT & PLOCK));  //    PLL
  PLLCON_bit.PLLC=1;                //  PLL   
  PLLFEED=0xAA;
  PLLFEED=0x55;

// MAM    
  MAMCR_bit.MODECTRL=0;   //  MAM
  MAMTIM_bit.CYCLES=3;    //   CCLK>40 
  MAMCR_bit.MODECTRL=2; // MAM ( MAM  )
  APBDIV_bit.APBDIV=0;   //.   PLL   #define  hardware.h
 
// GPIO
  PINSEL0=0; //  P0   GPIO
  PINSEL1=0; //  P0  GPIO

//   GPIO
                 //   
  IO0DIR_bit.P0_10=0; //   Ent (0)
  IO0DIR_bit.P0_11=0; //   Ret (1)     
  IO0DIR_bit.P0_12=0; //   Sel (2)
 
  IO0DIR_bit.P0_30=1; //    
  IO0DIR_bit.P0_27=1; //   
  IO0DIR_bit.P0_28=1; //         
  
  IO1DIR_bit.P1_16=1; //    HD44780 
  IO1DIR_bit.P1_17=1;
  IO1DIR_bit.P1_18=1;
  IO1DIR_bit.P1_19=1;
  
  IO1DIR_bit.P1_20=1;
  IO1DIR_bit.P1_21=1;
  IO1DIR_bit.P1_22=1;
  IO1DIR_bit.P1_23=1;
  
  KAN0_CLR;  //        
  ZWUK_CLR;  //    
  TEST_CLR;  //     
    
  IO1CLR=0xFF0000;
  //0b0000 0000 1111 1111 0000 0000 0000 0000     P1.16 ... P1.23
  
}

//--------------------------------------------------------------------------------
// 
//--------------------------------------------------------------------------------
void INTERRUPTSinit(void)
{
 // MEMMAP = 2;  //    SRAM      SRAM

//  
  VICProtection = 0;  //  VIC     
  VICIntEnClear = 0xffffffff;    //   
  VICDefVectAddr = (unsigned int)&TimerInterrupt; //    
  VICIntSelect &= ~VIC_TIMER0_bit; //  IRQ   0
  VICVectAddr1 = (unsigned int)&TimerInterrupt; //    
  VICVectCntl1 = 0x20 | VIC_TIMER0; //      0
  VICIntEnable = VIC_TIMER0_bit;    //     0
  
  VICIntSelect &= ~VIC_UART0_bit;  //  IRQ  UART0
  VICVectAddr2 = (unsigned int)&UART0Interrupt; //    
  VICVectCntl2 = 0x20 | VIC_UART0; //     UART0
  VICIntEnable = VIC_UART0_bit;    //    UART0
    
  VICIntSelect &= ~VIC_UART1_bit;  //  IRQ  UART1
  VICVectAddr3 = (unsigned int)&UART1Interrupt; //    
  VICVectCntl3 = 0x20 | VIC_UART1; //     UART1
  VICIntEnable = VIC_UART1_bit;    //    UART1

  VICIntSelect &= ~VIC_I2C_bit;  //  IRQ  I2C.
  VICVectAddr4 = (unsigned int)&I2CInterrupt; //    
  VICVectCntl4 = 0x20 | VIC_I2C; //     I2C.
  VICIntEnable = VIC_I2C_bit;    //    I2C.
}

//------------------------------------------------------------------------------------
//   IRQ
//------------------------------------------------------------------------------------
__irq __arm void IRQ_Handler(void)
{
  void (*interrupt_function)();
  unsigned int vector;
  vector = VICVectAddr;                     //      VIC
  interrupt_function = (void(*)())vector;
  (*interrupt_function)();                  //    
  VICVectAddr = 0;                          //    VIC
}

//------------------------------------------------------------------------------------
//-   TIMER0 --------------------------------------------
//------------------------------------------------------------------------------------
static void TimerInterrupt()
{

//      
//-------------------------------------------------------------------------------------
//  if (test_s == OFF)   {test_s=ON; TEST_SET;}
//  else   {test_s=OFF; TEST_CLR;} 
    
//       
  if (knoptick++ >= (Del_kn))    //      
    {                       
    knoptick = 0;
   
    opros_kn0();   //  0
    opros_kn1();   //  1
    opros_kn2();   //  2
    }

//         
//------------------------------------------------------------------------------------- 
//     
//-------------------------------------------------------------------------------------  
 if (zwuk_H_tick++ >= (Del_zwuk_H))    //           
   {                       
    zwuk_H_tick = 0; 
    
    //     
    if (zwuk_H_s == 0)   {zwuk_H_s = 1;}
    else    {zwuk_H_s = 0;}  
    
    if   (zwuk_H_ON == 1)  //        , 
       //                      
      {                     
      if  (zwuk_H_s == 1) {ZWUK_SET;}
      else   {ZWUK_CLR;}
 
      //        ,
      if (dlit_zwuk_H++ >= (pred_dlit_H)) 
          {
           dlit_zwuk_H = 0; //       
           zwuk_H_ON = 0;  // c      
           ZWUK_CLR;   //   
          }    
      }    
   }

//     
//-----------------------------------------------------------------------------------  
 if (zwuk_L_tick++ >= (Del_zwuk_L))    //           
   {                       
    zwuk_L_tick = 0; 
    
    //     
    if (zwuk_L_s == 0)   {zwuk_L_s = 1;}
    else    {zwuk_L_s = 0;}  
    
    if   (zwuk_L_ON == 1)  //        , 
       //                      
      {                     
      if  (zwuk_L_s == 1) {ZWUK_SET;}
      else   {ZWUK_CLR;}
 
      //        ,
      if (dlit_zwuk_L++ >= (pred_dlit_L)) 
          {
           dlit_zwuk_L = 0; //       
           zwuk_L_ON = 0;  // c      
           ZWUK_CLR;   //   
          }    
      }    
   }
  
//-------------------------------------------------------------------------------------  
  T0IR = 0xff; //      0
}

//------------------------------------------------------------------------------------
//-   UART0 --------------------------------------------
// ,    
//------------------------------------------------------------------------------------
static void UART0Interrupt()
{
   unsigned int   tempor0;
  
 if (U0IIR_bit.IP == 0)  
 { 
   switch(U0IIR_bit.IID)
   {
    case 0x1:  // THRE
               //    U0IIR 
    break;
    case 0x2:  // RDA
       {
       UART0rx_byte();  //   UART0
                        //    U0RBR  
       rx0_byte_f = 1; //     UART0  
       }  
    break;
    case 0x3:  // RLS
      {
      tempor0 = U0LSR;  //     U0LSR 
      tempor0 = tempor0;  
      }
    break;  
    case 0x6:  // CTI
      {
      UART0rx_byte();  //   UART0
                        //    U0RBR  
      rx0_byte_f = 1; //     UART0  
      }
    break; 
    default:
    break;
   }
 } 

//---------   --------------------------------------------------------- 
//------------------------------------------------------------------------------------
  switch(rejim_ustr)
    {
      case REG_ISH: //  
      case REG_MAST:  // -   
      { }   //    
      break; 
      case REG_SUPER:  // --
      { 
           if (rx0_byte_f == 1) //     UART0
            {
            rx0_byte_f = 0;  //     UART0   
            UART1tx_byte(rx0_byte);   //  ()      
            }                           //   
      }
      break; 
       
    }  
}  

//------------------------------------------------------------------------------------
//-   UART1 --------------------------------------------
// ,        
//------------------------------------------------------------------------------------
static void UART1Interrupt()
{
  
 unsigned int   tempor1;
  
 if (U1IIR_bit.IP == 0)  
 { 
   switch(U1IIR_bit.IID)
   {
    case 0x1:  // THRE
               //    U1IIR 
    break;
    case 0x2:  // RDA
       {
       UART1rx_byte();  //   UART1
                        //    U1RBR  
       rx1_byte_f = 1; //     UART1  
       }  
    break;
    case 0x3:  // RLS
      {
      tempor1 = U1LSR;  //     U1LSR 
      tempor1 = tempor1;  
      }
    break;  
    case 0x6:  // CTI
      {
      UART1rx_byte();  //   UART1
                        //    U1RBR  
      rx1_byte_f = 1; //     UART1  
      }
    break;
    case 0x0:  //   
      {
      tempor1 = U1MSR;  //     U1MSR 
      tempor1 = tempor1;  
      }
    break;  
    default:
    break;
   }
 }   

//---------   --------------------------------------------------------- 
//------------------------------------------------------------------------------------
  switch(rejim_ustr)
    {
      case REG_ISH: //  
      case REG_MAST:  // -  
      { 
         if (rx1_byte_f == 1) //     UART1
           {
            rx1_byte_f = 0;  //     UART1   
      
//          ---------------------    
          if  (tx_Command == ON)    //        , ..              
                                //            
              {     
              if (rx1_byte == RESPONSE_START_CODE1)  {k = 0;} //     , 
                                                              //    
               ACK_Packet[k] = rx1_byte; //      
                k++; 
                if (k == SB_OEM_PKT_SIZE)  //     ,       
                   {                   
                          tx_Command = OFF;      //           
                          rx_ACK_Command = ON;   //          
                          
                          if (CheckChkSumOfRpsAckPkt(ACK_Packet) == OK) //          
                             {   //      ,
                             rx_ACK_Command_ERR = OFF;  //          
                             }
                          else   
                             {  //      ,
                             rx_ACK_Command_ERR = ON;  //           
                             }
                   }
              }        
//---------------------------------------------------------------------------------            
           }
      }
      break; 
      case REG_SUPER:  // --
      { 
         if (rx1_byte_f == 1) //     UART1
            {
            rx1_byte_f = 0;  //     UART1   
            UART0tx_byte(rx1_byte);   //  ()      
            }    
      }
      break; 
      
    }  
}

//----------------------------------------------------------------------------------
//-   I2C --------------------------------------------
//----------------------------------------------------------------------------------
static void I2CInterrupt()
{
  switch(I2STAT)
       {
        case (0x08): //    START
             I2CONCLR = 0x20; //  START I2C
             I2DAT=I2C_EEPROM_W; //        (W)
             //174=0b10101110:   I2C - EEPROM (1010),
             //  I2C   (111)    (0)
        break;
        case (0x10): //     START
             I2CONCLR = 0x20; //  START I2C
             I2DAT=I2C_EEPROM_R; //        (R)
             //175=0b10101111:   I2C - EEPROM (1010),
             //  I2C   (111)    (1)
             //    
        break; 
        case (0x18): //     + W,  ACK
             //     EEPROM 24LC64
             I2DAT=(I2C_addres & 0xFF00)>>8;
             //     
             NUM_byte = 0;
        break;
        case (0x28): //    ,  ACK
             switch(NUM_byte)
              {
               case (0): //      
                   //     EEPROM 24LC64
                   I2DAT=(I2C_addres & 0xFF);
                   //     
                   NUM_byte = 1;
               break;
               case (1): //      
                   switch(wr_rd)
                     {
                       case (0):
                       //    EEPROM 24LC64
                       I2DAT=I2Cwr_byte;
                       //     
                       NUM_byte = 2;
                       break;
                       case (1):
                       //   START I2C
                       I2CONSET = 0x20; //  START
                       break;
                       default:
                       break;
                     }
               break;
               case (2): //    
                   I2CONSET = 0x10; //   STOP I2C
                   //     
                   NUM_byte = 0;
                   end_wr = 1; //   
               break;
               default:
               break;
              }
        case (0x40): //     + R,  ACK
        I2CONCLR = 0x04; //  ACC I2C,   NOT ACK
        break;
        case (0x58): //    ,  NOT ACK
        I2CONSET = 0x10; //   STOP I2C
        end_rd = 1; //   
        break;
        default:
        break;
       }
 I2CONCLR = 0x08; //    I2C
}

//------------------------------------------------------------------------------------
//   TIMER0 -----------------------------------------
//------------------------------------------------------------------------------------
void TIMER0initstart()
{
  T0TCR = 0; //   0 (  !)
  T0CCR = 0; //    
  T0EMR = 0; //    
  T0PC = 0; //    (  =1).
  T0MR0 = PCLK/DEL_TIM0; //    
  T0MCR = 3; //     MR0 (  0).
  T0TCR = 1; //    0  (  !)
}
//------------------------------------------------------------------------

     


            
            
            
            
            
            
            
            
            
            