//----------------------------------------------------------------------------
//    
//----------------------------------------------------------------------------
#include <intrinsics.h> //     
#include <NXP/iolpc2129.h> //     

//     
#define VIC_TIMER0_bit (1 << VIC_TIMER0)  //    0
#define VIC_UART0_bit  (1 << VIC_UART0)   //   UART0 
#define VIC_UART1_bit  (1 << VIC_UART1)   //   UART1 
#define VIC_I2C_bit    (1 << VIC_I2C)     //   I2C

//  
#define FOSC     14745600         //    
#define VALUEOFM 4                // PLLCFG_bit.MSEL=3
#define CCLK     (FOSC*VALUEOFM)  //CCLK = 58,9824 
#define PCLK     (CCLK/4)         // APBDIV_bit.APBDIV=0;
#define PLOCK    0x0400

//FCCO = CCLK * 2 * P = 156-320 ,   P=2,   PLLCFG_bit.PSEL=1;

//      
#define  num_Ver         1    //    
#define  num_coma_Ver    0    //    

//      
#define   tik_s05     420000   // 50 
#define   tik_s1      850000   // 100 
#define   tik_s2     1700000   // 200 
#define   tik_s3     2550000   // 300 
#define   tik_s5     4000000   // 500 
#define   tik_1s     8000000   // 1 
#define   tik_2s    16000000   // 2 
#define   tik_3s    24000000   // 3 
#define   tik_5s    40000000   // 5 
#define   tik_7s    56000000   // 7 
#define   tik_9s    72000000   // 9 

//   
#define    REG_ISH          0  //    
#define    REG_MAST         1  // -  
#define    REG_SUPER        2  // --

//   - 
#define    PODREG_MAST_U   0  //   -             
#define    PODREG_MAST_I   1  //   -           
#define    PODREG_MAST_G   2  //   -         
#define    PODREG_MAST_C   3  //   -   ,        
#define    PODREG_MAST_S   4  //   -     --

// ,         
#define    level_out_AKT_H    0  //       ,    
#define    level_out_AKT_L    1  //       ,                                           
#define    level_out_AKT_DEF  level_out_AKT_H //        , 
                                //        I2C 

// ,         
#define    interval_out_MAX   15  //   (   )        
#define    interval_out_MIN   1  //   (   )      
#define    interval_out_DEF   2  //        I2C  ( ) 
                                 //       

// ,         
#define    ID_GT511_MAX       199  //   ( )       
#define    ID_GT511_MIN       0  //   ( )     
#define ID0    0       //  ID = 0,   -,     GT-511 
#define ID1    1       //  ID = 1,   --,     GT-511

// ,      
#define    ID_dostup_ON        1   //    ,      
#define    ID_dostup_OFF       0   //    ,      
#define    ID_dostup_DEF       ID_dostup_ON  //         

//  ,      
#define DEL_TIM0     10000  //      0 
                          //  10000 
#define Del_kn       8    //       
#define Del_zwuk_H   4    //       
#define Del_zwuk_L   26   //       

//          
#define ERR_NO_GT511  '0'   //  -    
#define ERR_ER_GT511  '1'   //  -      
#define ERR_NO_I2C    '2'   //  -    I2C   24LC64
#define ERR_ER_I2C    '3'   //  -    I2C  24LC64

// ,   ,         I2C
#define   I2C_TEST_DATA  0xAA //      /  24LC64

#define   I2C_START_ADDR   10  //    24LC64  -          
#define   I2C_TEST_ADDR    I2C_START_ADDR + 1  //   24LC64   

#define   level_out_I2C_ADDR       I2C_START_ADDR + 10  //   24LC64          
#define   interval_out_I2C_ADDR    I2C_START_ADDR + 12  //   24LC64      ,       
                                       //    
#define   ID_dostup_START_I2C_ADDR  I2C_START_ADDR + 20  //    24LC64        

//   ,    
void CPUinit(void); 
void INTERRUPTSinit(void);
__irq __arm void IRQ_Handler(void); 
void TIMER0initstart();   //    0
static void TimerInterrupt(); //      0
static void UART0Interrupt(); //     UART0
static void UART1Interrupt(); //     UART1
static void I2CInterrupt(); //     I2C

//--------------------------------------------------------------------------------
//  
#define FALSE     0
#define OFF       0
#define DOWN      0
#define LOW       0

#define TRUE      1
#define SUCCESS   1
#define ON        1
#define UP        1
#define HIGH      1

//--------------------------------------------------------------------------------
// ,    
#define  BIT_SET(address,bit)     (address |= (1 << bit))
#define  BIT_CLEAR(address,bit)   (address &= ~(1 << bit))
#define  BIT_TEST(address,bit)    (address & (1 << bit))
//--------------------------------------------------------------------------------

//-   
#define  DREB_KN0_K   50
#define  DREB_KN1_K   50
#define  DREB_KN2_K   50

//    
#define   IN_KNOP0      IO0PIN_bit.P0_10  //  0
#define   IN_KNOP1      IO0PIN_bit.P0_11  //  1
#define   IN_KNOP2      IO0PIN_bit.P0_12  //  2

//   
#define   LCD_RW            IO1PIN_bit.P1_17   // RW (/)
#define   LCD_RS            IO1PIN_bit.P1_18   // RS (/)
#define   LCD_E             IO1PIN_bit.P1_19   // E ( /)
#define   LCD_D4            IO1PIN_bit.P1_20   //-----------------------
#define   LCD_D5            IO1PIN_bit.P1_21   //  
#define   LCD_D6            IO1PIN_bit.P1_22   //
#define   LCD_D7            IO1PIN_bit.P1_23   //-----------------------

// /  
#define   LCD_RW_CLR    IO1CLR_bit.P1_17=1
#define   LCD_RW_SET    IO1SET_bit.P1_17=1
#define   LCD_RS_CLR    IO1CLR_bit.P1_18=1
#define   LCD_RS_SET    IO1SET_bit.P1_18=1
#define   LCD_E_CLR     IO1CLR_bit.P1_19=1
#define   LCD_E_SET     IO1SET_bit.P1_19=1
#define   LCD_D4_CLR    IO1CLR_bit.P1_20=1
#define   LCD_D4_SET    IO1SET_bit.P1_20=1
#define   LCD_D5_CLR    IO1CLR_bit.P1_21=1
#define   LCD_D5_SET    IO1SET_bit.P1_21=1
#define   LCD_D6_CLR    IO1CLR_bit.P1_22=1
#define   LCD_D6_SET    IO1SET_bit.P1_22=1
#define   LCD_D7_CLR    IO1CLR_bit.P1_23=1
#define   LCD_D7_SET    IO1SET_bit.P1_23=1

// /   
#define   ZWUK_CLR      IO0CLR_bit.P0_27=1
#define   ZWUK_SET      IO0SET_bit.P0_27=1

// /     
#define   TEST_CLR      IO0CLR_bit.P0_28=1
#define   TEST_SET      IO0SET_bit.P0_28=1

// /      
#define   KAN0_CLR      IO0CLR_bit.P0_30=1
#define   KAN0_SET      IO0SET_bit.P0_30=1

//      HD44780
#define rus_b         0xB2  //  
#define rus_v         0xB3  //  
#define rus_g         0xB4  //  
#define rus_d         0xE3  //  
#define rus_eo        0xA2  //  e''
#define rus_j         0xB6  //  
#define rus_z         0xB7  //  
#define rus_i         0xB8  //  
#define rus_ik        0xB9  //  
#define rus_k         0xBA  //  
#define rus_l         0xBB  //  
#define rus_m         0xBC  //  
#define rus_n         0xBD  //  
#define rus_p         0xBE  //  
#define rus_t         0xBF  //  
#define rus_f         0xE4  //  
#define rus_tz        0xE5  //  
#define rus_ch        0xC0  //  
#define rus_sch       0xC1  //  
#define rus_ssch      0xE6  //  
#define rus_m_zn      0xC4  //  
#define rus_t_zn      0xC2  //  
#define rus_ii        0xC3  //  
#define rus_ei        0xC5  //  
#define rus_ju        0xC6  //  
#define rus_ja        0xC7  //  

#define rus_B         0xA0  //  
#define rus_G         0xA1  //  
#define rus_D         0xE0  //  
#define rus_J         0xA3  //  
#define rus_Z         0xA4  //  
#define rus_I         0xA5  //  
#define rus_IK        0xA6  //  
#define rus_L         0xA7  //  
#define rus_P         0xA8  //  
#define rus_U         0xA9  //  
#define rus_F         0xAA  //  
#define rus_TZ        0xE1  //  
#define rus_CH        0xAB  //  
#define rus_SCH       0xAC  //  
#define rus_SSCH      0xE2  //  
#define rus_T_ZN      0xAD  //  
#define rus_II        0xAE  //  
#define rus_EI        0xAF  //  
#define rus_JU        0xB0  //  
#define rus_JA        0xB1  //  
#define polno         0xFF  //   
#define pusto         0x20  //   





